$('#tutorial').on('click', function () {
  $(document).ready(async function () {
    const driver = new Driver({
      doneBtnText: 'Sair',
      closeBtnText: 'Fechar',
      nextBtnText: 'Próximo',
      prevBtnText: 'Anterior',
      allowClose: false
    });
    driver.defineSteps([

      {
        element: '#btnFiltros',
        popover: {
          title: 'Botão Filtros',
          description: 'Clique aqui para filtrar a consulta.',
          position: 'right'
        }
      },
      {
        element: '#btnNovoTemplate',
        popover: {
          title: 'Botão Incluir',
          description: 'Clique aqui para iniciar o cadastro de um novo status.',
          position: 'right'
        }
      },
      {
        element: '#tabelaCadDesembaraco',
        popover: {
          title: 'Tabela Marcas',
          description: 'Aqui estão os dados dos status cadastrados.',
          position: 'top'
        }
      },
      {
        element: '#tutorialTabela',
        popover: {
          title: 'Opções de Alterar e Excluir',
          description: 'Neste botão, podemos escolher entre alterar ou excluir o registro.',
          position: 'top'
        }
      }

    ]);
    driver.start();
  });
});
//Grid Acesso//,
$(document).ready(async function () {
  await buscaStatus(false)

  // autocompleta
  $('#txtCadDesembaracoConsulta').autocompleta(1, `JSON={ "tabela":"DESEMBARACO", "camposSelect":[ "codigo chave", "descricao descricao", "CIDADE", "UF", "PAIS"], "where": null}`);

  // pesquisa
  $('#btnConsultaDesembaraco').pesquisa('#txtCadDesembaracoConsulta', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"DESEMBARACO", "camposSelect":[ "codigo", "descricao"], "where": null}`, 'Cadastro de Desembaraço', 'CADDESEMBARACO');

  // limpacampo
  $('#btnLimpaConsulta, #btnLimparFiltros').on('click', function () {
    $('#txtCadDesembaracoConsulta').val('');
  });

  $('#btnFiltros').on('click', function () {
    $('#modal-filtros').modal('show');
  });

  async function buscaStatus(botao) {
    $.LoadingOverlay("show");
    // $('#btnConsultar').trigger('click');
    try {
      let response
      if (botao) {
        response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ 
          "tabela":"DESEMBARACO", "camposSelect":[ "DESEMBARACO.CODIGO", "DESEMBARACO.DESCRICAO", "CIDADE.NOME AS CIDADE", "DESEMBARACO.UF", "CADPAIS.NOME AS PAIS"],
          "leftJoin": [{
            "tabela": "CIDADE", "condicao": "CIDADE.CODIGO = DESEMBARACO.CIDADE"},{
            "tabela": "CADPAIS", "condicao": "CADPAIS.CODIGO = DESEMBARACO.PAIS"}],  
          "where": ["1=1", "DESEMBARACO.CODIGO='${pegaChave('#txtCadDesembaracoConsulta')}'"]}`, 1000);
      } else {
        response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ 
          "tabela":"DESEMBARACO", "camposSelect":[ "DESEMBARACO.CODIGO", "DESEMBARACO.DESCRICAO", "CIDADE.NOME AS CIDADE", "DESEMBARACO.UF", "CADPAIS.NOME AS PAIS"],
          "leftJoin": [{
            "tabela": "CIDADE", "condicao": "CIDADE.CODIGO = DESEMBARACO.CIDADE"},{
            "tabela": "CADPAIS", "condicao": "CADPAIS.CODIGO = DESEMBARACO.PAIS"}],  
          "where": ["1=1"]}`, 1000);
      }


      if (!response) {
        $.LoadingOverlay("hide");
        return;
      }

      let jsonStr = await response.json();
      if (response.status != 200) {
        $.LoadingOverlay("hide");
        msgErro(jsonStr.RESULT[0].mensagem);
        return;
      }

      let colunasInvisiveis = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'));
      if (colunasInvisiveis == null || colunasInvisiveis.acessoCadDesembaraco == undefined) {
        localStorage.setItem('colunasInvisiveisRelatorios', JSON.stringify({ ...colunasInvisiveis, acessoCadDesembaraco: ['EMPRESA'] }));
        colunasInvisiveis = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'));
      }

      $('#tabelaCadDesembaraco').DataTable({
        destroy: true,
        lengthChange: true,
        paging: true,
        searching: true,
        scrollX: true,
        scrollY: '350px',
        "autoWidth": true,
        "data": jsonStr.RESULT[0],
        "columns": [{
          data: "CODIGO",
          title: "Código"
        },
        {
          data: "DESCRICAO",
          title: "Descrição"
        },
        {
          data: "CIDADE",
          title: "Cidade"
        },
        {
          data: "UF",
          title: "UF"
        },
        {
          data: "PAIS",
          title: "País"
        },
        ],
        "columnDefs": [{
          targets: [0], render: function (data, type, row) {
            return retornaBotaoOpcoes(data);
          }
        }]
      });

      $('#tabelaCadDesembaraco_length').prepend('<button class="buttonColVis" id="buttonColVis"><i class="fas fa-cogs"></i></button>');
      $('#tabelaCadDesembaraco_length').prepend('<button class="buttonExcel" id="buttonExcel"><i class="fas fa-file-excel"></i></button>');

      $('#buttonColVis').prop('title', 'Configurar colunas visíveis')
      $('#buttonExcel').prop('title', 'Exportar')

      $('#buttonColVis').on('click', async function () {
        $.LoadingOverlay('show');
        $('#modal-ColunasVisiveis').modal('show');
        $.LoadingOverlay('hide');
      });

      $('#buttonExcel').on('click', async function () {
        const dados = $("#tabelaCadDesembaraco").DataTable().data().toArray();
        await exportaCSV("", "", undefined, null, 'Relatório da aba de acesso cadastro de Desembaraço', '', '', 999, false, false, dados);
      });

      $('#tabelaCadDesembaraco').DataTable().columns().every(function () {
        if ((colunasInvisiveis.acessoCadDesembaraco).indexOf(this.dataSrc()) != -1) {
          this.visible(false);
        }
      });

    } catch (error) {
      console.error(error);
    } finally {
      $('#modal-filtros').modal('hide');
      $.LoadingOverlay("hide");
    }
  }

  $('#modal-ColunasVisiveis').on('show.bs.modal', function () {
        const cols = [];
        colunasInvisiveis = JSON.parse(localStorage.getItem('colunasInvisiveisRelatorios'))

        $('#tabelaCadDesembaraco').DataTable().columns().every(function () {
            cols.push({
                'title': $(this.header()).text(),
                'data': this.dataSrc()
            });
        });

        adicionaColunas(cols, colunasInvisiveis.acessoCadDesembaraco ?? ['EMPRESA']);
    });

    $('#btnConfirmarColunas').on('click', async function () {
        try {
            $.LoadingOverlay('show');

            const novasColunas = retornaNovasColunasInvisiveis();
            removeColunasFixas(novasColunas, ["CODIGO"]);
            localStorage.setItem('colunasInvisiveisRelatorios', JSON.stringify({ ...colunasInvisiveis, acessoCadDesembaraco: novasColunas }));

            $('#tabelaCadDesembaraco').DataTable().columns().visible(true);

            $('#tabelaCadDesembaraco').DataTable().columns().every(function () {
                if ((novasColunas).indexOf(this.dataSrc()) != -1) {
                    this.visible(false);
                }
            });

        } finally {
            $.LoadingOverlay('hide');
            $('#modal-ColunasVisiveis').modal('hide');
        }
    });

  $('#btnConsultar').on('click', async function () {
    await buscaStatus(true);
  })

  $('#tabelaCadDesembaraco').on('click', '#btn-editar', async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $('#tabelaCadDesembaraco').DataTable().row($(this).parents('tr')).data();
      let registroLiberado = await verificarRegistro('CADDESEMBARACO', data.CODIGO);
      if (registroLiberado) {
        window.location.href = `caddesembaraco/${data.CODIGO}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }
  });

  $('#tabelaCadDesembaraco').on('click', '#btn-excluir', async function () {
    if (permissaoUsuarioLogado.EXCLUI == 'S') {
      msgAlerta('Você realmente deseja excluir esse registro?', async () => {
        const data = $('#tabelaCadDesembaraco').DataTable().row($(this).parents('tr')).data();
        await excluiRegistro(data);
      });
    } else {
      msgAlertaSemConfirmacao("Sem permissão para excluir!");
    }
  });

  async function excluiRegistro(data) {
    try {
      $.LoadingOverlay("show");
      try {

        let response = await requisicao('DELETE', '/Sisplan/cadastros/V1/caddesembaraco?', `CODIGOCADDESEMBARACO=${encodeURIComponent(data.CODIGO)}`, null)
        if (!response) {
          return;
        }
        if (response.status != 200) {
          let jsonStr = await response.json();
          msgErro(jsonStr.mensagem);
          return;
        }

        toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
          toastClass: "success",
          iconClasses: {
            error: "alert-error",
            info: "alert-info",
            success: "alert-success",
            warning: "alert-warning",
          },
          positionClass: "toast-top-center",
          progressBar: true,
          timeOut: 3000,
          fadeOut: 1000,
          onHidden() {
            window.location.href = `${BASE_URI}/caddesembaraco`;
          },
        }).css({
          "margin-top": "20%",
          width: "500px",
          "max-width": "500px",
        });

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay("hide");
    }
  }

  function retornaBotaoOpcoes(data) {
    var retorno = '<div style="text-align:start;"> ' +
      '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" id="tutorialTabela" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
      '      ' + data + ' ' +
      '    </button> ' +
      '    <div class="dropdown-menu"> ' +
      '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
      '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
      '</div>';
    return retorno;
  };

  async function permissaoAcessos(tela) {
    try {
      $.LoadingOverlay("show");

      let object = new Object();
      object.resultado = true;
      object.mensagem = "";

      if (getCookie("cod_usuario") == "0000") {
        object.ALTERA = "S";
        object.CONSULTA = 'S';
        object.EXCLUI = 'S';
        object.INCLUI = 'S';
        return object;
      }

      try {
        const codusuario = `'${getCookie("cod_usuario")}'`;
        const response = await requisicao(
          "GET",
          `/Sisplan/AcessoMenu/v1/Acesso?`,
          `codusuarios=${codusuario}&telas='${tela}'`,
          null,
          60000
        );

        if (!response) {
          msgErro("Erro ao buscar permissões da tela.");
          return;
        }

        let valida = await response.json();
        if (response.status != 200) {
          console.error(valida.RESULT[0].mensagem);
          msgErro("Erro ao buscar permissões da tela.");
          return;
        }

        if (valida.length <= 0) {
          object.ALTERA = "N";
          object.CONSULTA = 'N';
          object.EXCLUI = 'N';
          object.INCLUI = 'N';
          return object;
        }

        return valida[0];
      } catch (error) {
        console.error(error);
        msgErro("Erro ao buscar permissões da tela.");
      }
    } finally {
      $.LoadingOverlay("hide");
    }
  }
  const permissaoUsuarioLogado = await permissaoAcessos("CADDESEMBARACO");

  $('#tabelaCadDesembaraco').on('dblclick', 'tr', async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $('#tabelaCadDesembaraco').DataTable().row($(this)).data();
      let registroLiberado = await verificarRegistro('CADDESEMBARACO', data.CODIGO);
      if (registroLiberado) {
        window.location.href = `caddesembaraco/${data.CODIGO}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }
  });
});